/* A lexical scanner generated by flex */

/* Scanner skeleton version:
 * $Header: /home/ncvs/src/usr.bin/lex/skel.c,v 1.1.1.2.2.1 1997/02/23 01:37:10 joerg Exp $
 */

#define FLEX_SCANNER
#define YY_rs__FLEX_MAJOR_VERSION 2
#define YY_rs__FLEX_MINOR_VERSION 5

#include <stdio.h>


/* cfront 1.2 defines "c_plusplus" instead of "__cplusplus" */
#ifdef c_plusplus
#ifndef __cplusplus
#define __cplusplus
#endif
#endif


#ifdef __cplusplus

#include <stdlib.h>
#include <unistd.h>

/* Use prototypes in function declarations. */
#define YY_rs__USE_PROTOS

/* The "const" storage-class-modifier is valid. */
#define YY_rs__USE_CONST

#else	/* ! __cplusplus */

#if __STDC__

#define YY_rs__USE_PROTOS
#define YY_rs__USE_CONST

#endif	/* __STDC__ */
#endif	/* ! __cplusplus */

#ifdef __TURBOC__
 #pragma warn -rch
 #pragma warn -use
#include <io.h>
#include <stdlib.h>
#define YY_rs__USE_CONST
#define YY_rs__USE_PROTOS
#endif

#ifdef YY_rs__USE_CONST
#define yy_rs_const const
#else
#define yy_rs_const
#endif


#ifdef YY_rs__USE_PROTOS
#define YY_rs__PROTO(proto) proto
#else
#define YY_rs__PROTO(proto) ()
#endif

/* Returned upon end-of-file. */
#define YY_rs__NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_rs__SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN_rs_.
 */
#define BEGIN_rs_ yy_rs__start = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN_rs_ to return to the state.  The YY_rs_STATE alias is for lex
 * compatibility.
 */
#define YY_rs__START ((yy_rs__start - 1) / 2)
#define YY_rs_STATE YY_rs__START

/* Action number for EOF rule of a given start state. */
#define YY_rs__STATE_EOF(state) (YY_rs__END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_rs__NEW_FILE yy_rs_restart( yy_rs_in )

#define YY_rs__END_OF_BUFFER_CHAR 0

/* Size of default input_rs_ buffer. */
#define YY_rs__BUF_SIZE 16384

typedef struct yy_rs__buffer_state *YY_rs__BUFFER_STATE;

extern int yy_rs_leng;
extern FILE *yy_rs_in, *yy_rs_out;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

/* The funky do-while in the following #define is used to turn the definition
 * int a single C statement (which needs a semi-colon terminator).  This
 * avoids problems with code like:
 *
 * 	if ( condition_holds )
 *		yy_rs_less( 5 );
 *	else
 *		do_something_else();
 *
 * Prior to using the do-while the compiler would get upset at the
 * "else" because it interpreted the "if" statement as being all
 * done when it reached the ';' after the yy_rs_less() call.
 */

/* Return all but the first 'n' matched characters back to the input_rs_ stream. */

#define yy_rs_less(n) \
	do \
		{ \
		/* Undo effects of setting up yy_rs_text. */ \
		*yy_rs__cp = yy_rs__hold_char; \
		YY_rs__RESTORE_YY_rs__MORE_OFFSET \
		yy_rs__c_buf_p = yy_rs__cp = yy_rs__bp + n - YY_rs__MORE_ADJ; \
		YY_rs__DO_BEFORE_ACTION; /* set up yy_rs_text again */ \
		} \
	while ( 0 )

#define unput_rs_(c) yy_rs_unput_rs_( c, yy_rs_text_ptr )

/* The following is because we cannot portably get our hands on size_t
 * (without autoconf's help, which isn't available because we want
 * flex-generated scanners to compile on their own).
 */
typedef unsigned int yy_rs__size_t;


struct yy_rs__buffer_state
	{
	FILE *yy_rs__input_rs__file;

	char *yy_rs__ch_buf;		/* input_rs_ buffer */
	char *yy_rs__buf_pos;		/* current position in input_rs_ buffer */

	/* Size of input_rs_ buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_rs__size_t yy_rs__buf_size;

	/* Number of characters read into yy_rs__ch_buf, not including EOB
	 * characters.
	 */
	int yy_rs__n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_rs__is_our_buffer;

	/* Whether this is an "interactive" input_rs_ source; if so, and
	 * if we're using stdio for input_rs_, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input_rs_ after
	 * each newline.
	 */
	int yy_rs__is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_rs__at_bol;

	/* Whether to try to fill the input_rs_ buffer when we reach the
	 * end of it.
	 */
	int yy_rs__fill_buffer;

	int yy_rs__buffer_status;
#define YY_rs__BUFFER_NEW 0
#define YY_rs__BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_rs__EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input_rs_ source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yy_rs_restart()), so that the user can continue scanning by
	 * just pointing yy_rs_in at a new input_rs_ file.
	 */
#define YY_rs__BUFFER_EOF_PENDING 2
	};

static YY_rs__BUFFER_STATE yy_rs__current_buffer = 0;

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 */
#define YY_rs__CURRENT_BUFFER yy_rs__current_buffer


/* yy_rs__hold_char holds the character lost when yy_rs_text is formed. */
static char yy_rs__hold_char;

static int yy_rs__n_chars;		/* number of characters read into yy_rs__ch_buf */


int yy_rs_leng;

/* Points to current character in buffer. */
static char *yy_rs__c_buf_p = (char *) 0;
static int yy_rs__init = 1;		/* whether we need to initialize */
static int yy_rs__start = 0;	/* start state number */

/* Flag which is used to allow yy_rs_wrap()'s to do buffer switches
 * instead of setting up a fresh yy_rs_in.  A bit of a hack ...
 */
static int yy_rs__did_buffer_switch_on_eof;

void yy_rs_restart YY_rs__PROTO(( FILE *input_rs__file ));

void yy_rs__switch_to_buffer YY_rs__PROTO(( YY_rs__BUFFER_STATE new_buffer ));
void yy_rs__load_buffer_state YY_rs__PROTO(( void ));
YY_rs__BUFFER_STATE yy_rs__create_buffer YY_rs__PROTO(( FILE *file, int size ));
void yy_rs__delete_buffer YY_rs__PROTO(( YY_rs__BUFFER_STATE b ));
void yy_rs__init_buffer YY_rs__PROTO(( YY_rs__BUFFER_STATE b, FILE *file ));
void yy_rs__flush_buffer YY_rs__PROTO(( YY_rs__BUFFER_STATE b ));
#define YY_rs__FLUSH_BUFFER yy_rs__flush_buffer( yy_rs__current_buffer )

YY_rs__BUFFER_STATE yy_rs__scan_buffer YY_rs__PROTO(( char *base, yy_rs__size_t size ));
YY_rs__BUFFER_STATE yy_rs__scan_string YY_rs__PROTO(( yy_rs_const char *yy_rs__str ));
YY_rs__BUFFER_STATE yy_rs__scan_bytes YY_rs__PROTO(( yy_rs_const char *bytes, int len ));

static void *yy_rs__flex_alloc YY_rs__PROTO(( yy_rs__size_t ));
static void *yy_rs__flex_realloc YY_rs__PROTO(( void *, yy_rs__size_t ));
static void yy_rs__flex_free YY_rs__PROTO(( void * ));

#define yy_rs__new_buffer yy_rs__create_buffer

#define yy_rs__set_interactive(is_interactive) \
	{ \
	if ( ! yy_rs__current_buffer ) \
		yy_rs__current_buffer = yy_rs__create_buffer( yy_rs_in, YY_rs__BUF_SIZE ); \
	yy_rs__current_buffer->yy_rs__is_interactive = is_interactive; \
	}

#define yy_rs__set_bol(at_bol) \
	{ \
	if ( ! yy_rs__current_buffer ) \
		yy_rs__current_buffer = yy_rs__create_buffer( yy_rs_in, YY_rs__BUF_SIZE ); \
	yy_rs__current_buffer->yy_rs__at_bol = at_bol; \
	}

#define YY_rs__AT_BOL() (yy_rs__current_buffer->yy_rs__at_bol)

typedef unsigned char YY_rs__CHAR;
FILE *yy_rs_in = (FILE *) 0, *yy_rs_out = (FILE *) 0;
typedef int yy_rs__state_type;
extern char *yy_rs_text;
#define yy_rs_text_ptr yy_rs_text

static yy_rs__state_type yy_rs__get_previous_state YY_rs__PROTO(( void ));
static yy_rs__state_type yy_rs__try_NUL_trans YY_rs__PROTO(( yy_rs__state_type current_state ));
static int yy_rs__get_next_buffer YY_rs__PROTO(( void ));
static void yy_rs__fatal_error YY_rs__PROTO(( yy_rs_const char msg[] ));

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yy_rs_text.
 */
#define YY_rs__DO_BEFORE_ACTION \
	yy_rs_text_ptr = yy_rs__bp; \
	yy_rs_leng = (int) (yy_rs__cp - yy_rs__bp); \
	yy_rs__hold_char = *yy_rs__cp; \
	*yy_rs__cp = '\0'; \
	yy_rs__c_buf_p = yy_rs__cp;

#define YY_rs__NUM_RULES 47
#define YY_rs__END_OF_BUFFER 48
static yy_rs_const short int yy_rs__accept[230] =
    {   0,
        0,    0,   48,   46,    1,    2,   46,   45,   45,    3,
        0,   18,    0,    0,   16,   40,   28,   27,    0,    0,
       12,   23,   45,   19,   45,   20,   17,   24,    3,    0,
        0,   39,    0,    4,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    6,    0,    0,    0,
        5,   45,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,   45,    0,    0,    0,    0,    0,   14,    0,
        0,    0,    0,   38,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,   15,    0,   13,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,   31,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,   22,   44,   42,    0,    0,    0,   32,    0,    0,
        0,    0,   37,    0,    0,    0,   21,   43,   41,    0,
       26,    0,   30,    0,    0,    0,    0,    0,    0,    0,
       25,    0,   33,    0,    0,    0,    0,    0,    0,    0,
        0,   35,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,   34,   36,    0,    0,   11,

        0,    0,    0,    0,    0,    0,    0,    0,    9,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,   29,
        0,    0,   10,    7,    0,    0,    0,    8,    0
    } ;

static yy_rs_const int yy_rs__ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    2,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    4,    5,    6,    7,    7,    7,
        7,    7,    7,    7,    7,    7,    7,    1,    1,    1,
        1,    1,    8,    1,    9,   10,   11,    5,   12,    5,
       13,   14,   15,    5,    5,   16,    5,   17,   18,   19,
        5,   20,   21,   22,    5,   23,   24,    5,   25,    5,
        1,    5,    1,    1,    5,    1,   26,   27,   28,   29,

       30,   31,   32,   33,   34,    5,    5,   35,   36,   37,
       38,   39,    5,   40,   41,   42,   43,   44,   45,    5,
       46,   47,    1,    1,    1,    5,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yy_rs_const int yy_rs__meta[48] =
    {   0,
        1,    1,    1,    2,    2,    2,    2,    1,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2
    } ;

static yy_rs_const short int yy_rs__base[232] =
    {   0,
        0,    8,  313,  314,  314,  314,   13,    0,   51,  305,
       86,  314,    2,    0,   13,   17,  123,    1,  265,   23,
      314,   22,    0,  314,   21,    0,   22,    0,  303,   15,
       38,   42,   54,  314,   16,   48,   46,   47,   50,  271,
      268,  269,  270,  275,  264,  266,  314,  276,  275,  262,
        0,   53,   52,   57,   54,   61,   52,   74,   85,   82,
      267,  263,  261,  256,  255,  255,  251,  258,   65,  256,
      253,  285,   84,   79,   88,  107,   95,   90,  314,   98,
      103,  112,  248,  314,  251,  248,  249,  249,  240,  250,
      239,  239,  244,  249,  249,    0,  105,  314,  122,  118,

      120,  124,  121,  126,  130,  246,  245,  234,  247,  238,
      231,  230,  235,  238,  263,  231,  239,  133,  134,  138,
      141,  155,  147,  152,  149,  232,  226,  314,  220,  233,
      223,  233,  232,  228,  229,  225,  219,  160,  160,  157,
      157,  314,  314,  314,  155,  227,  210,  314,  217,  246,
      210,  213,  314,  201,  242,  210,  314,  314,  314,  156,
      314,  202,  314,  201,  200,  208,  206,  235,  202,  233,
      314,  206,  314,  189,  193,  186,  142,  206,  204,  226,
      190,  314,  198,  197,  200,  191,  178,  183,  192,  192,
      189,  184,  181,  213,  186,  314,  314,  185,  171,  314,

      144,  171,  172,  181,  180,  183,  165,  177,  314,  175,
      170,  160,  161,  167,  153,  158,  165,  145,  153,  314,
      115,  113,  314,  314,   74,   61,   46,  314,  314,  202,
        3
    } ;

static yy_rs_const short int yy_rs__def[232] =
    {   0,
      230,  230,  229,  229,  229,  229,  229,  231,  231,  231,
      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  231,  229,  231,  231,  231,  231,  231,  229,
      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      231,  231,  229,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  231,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  229,  229,  229,  231,  229,  229,  229,  229,

      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,

      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  229,  229,  229,  229,  229,  229,    0,  229,
      229
    } ;

static yy_rs_const short int yy_rs__nxt[362] =
    {   0,
        4,    5,    6,    7,   23,    9,   10,    4,    4,    5,
        6,    7,   34,    9,   10,    4,   11,   35,   35,  229,
       12,  229,   13,   14,   36,  229,   15,  229,   37,   34,
       38,   51,   53,   52,   57,   16,   17,   35,   35,   13,
       18,   19,   36,   20,   21,   15,   37,   38,   51,   54,
       48,   52,   53,   55,   57,   49,   16,   22,   24,   50,
       25,   26,   56,   58,   27,   59,   60,   54,   73,   60,
       74,   55,   75,   76,   28,  228,   78,   25,   26,   56,
       77,   61,   58,   27,   62,   59,   60,   73,  227,   60,
       74,   75,   79,   76,   80,   28,   30,   78,   91,   31,

       77,   82,   96,   97,  102,   81,   98,   92,   32,   33,
      226,   80,   79,   30,  101,  103,   99,  104,   31,  118,
      105,   82,   96,  102,   97,   81,   98,  100,  121,   32,
       33,   38,  120,   99,  101,  103,  104,  105,  118,  119,
      122,  123,  225,  124,  224,  121,  125,  100,   39,  138,
       40,  120,   41,   42,  139,  140,   43,  141,  143,  119,
      122,  123,   44,  124,   45,   46,  125,  142,  144,  138,
      145,  158,  157,  159,  139,  140,  143,  141,  160,  161,
      171,  184,  223,  205,  222,  185,  142,  206,  144,  158,
      145,  157,  221,  159,  220,  219,  218,  217,  160,  216,

      161,  171,    8,    8,  215,  214,  213,  212,  211,  210,
      209,  208,  207,  204,  203,  202,  201,  200,  199,  198,
      197,  196,  195,  194,  193,  192,  191,  190,  189,  188,
      187,  186,  183,  182,  181,  180,  179,  178,  177,  176,
      175,  174,  173,  172,  170,  169,  168,  167,  166,  165,
      164,  163,  162,  156,  155,  154,  153,  152,  151,  150,
      149,  148,  147,  146,  137,  136,  135,  134,  133,  132,
      131,  130,  129,  128,  127,  126,  117,  116,  115,  114,
      113,  112,  111,  110,  109,  108,  107,  106,   95,   94,
       93,   90,   89,   88,   87,   86,   85,   84,   83,   72,

       71,   70,   69,   68,   67,   66,   65,   64,   63,   29,
       47,   29,  229,    3,  229,  229,  229,  229,  229,  229,
      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      229
    } ;

static yy_rs_const short int yy_rs__chk[362] =
    {   0,
        1,    1,    1,    1,  231,    1,    1,    1,    2,    2,
        2,    2,   13,    2,    2,    2,    7,   14,   18,    0,
        7,    0,    7,    7,   15,    0,    7,    0,   16,   13,
       22,   25,   30,   27,   35,    7,    7,   14,   18,    7,
        7,    7,   15,    7,    7,    7,   16,   22,   25,   31,
       20,   27,   30,   32,   35,   20,    7,    7,    9,   20,
        9,    9,   33,   36,    9,   37,   38,   31,   52,   39,
       53,   32,   54,   55,    9,  227,   57,    9,    9,   33,
       56,   39,   36,    9,   39,   37,   38,   52,  226,   39,
       53,   54,   58,   55,   59,    9,   11,   57,   69,   11,

       56,   60,   73,   74,   78,   59,   75,   69,   11,   11,
      225,   59,   58,   11,   77,   80,   76,   81,   11,   97,
       82,   60,   73,   78,   74,   59,   75,   76,  101,   11,
       11,   17,  100,   76,   77,   80,   81,   82,   97,   99,
      102,  103,  222,  104,  221,  101,  105,   76,   17,  118,
       17,  100,   17,   17,  119,  120,   17,  121,  123,   99,
      102,  103,   17,  104,   17,   17,  105,  122,  124,  118,
      125,  139,  138,  140,  119,  120,  123,  121,  141,  145,
      160,  177,  219,  201,  218,  177,  122,  201,  124,  139,
      125,  138,  217,  140,  216,  215,  214,  213,  141,  212,

      145,  160,  230,  230,  211,  210,  208,  207,  206,  205,
      204,  203,  202,  199,  198,  195,  194,  193,  192,  191,
      190,  189,  188,  187,  186,  185,  184,  183,  181,  180,
      179,  178,  176,  175,  174,  172,  170,  169,  168,  167,
      166,  165,  164,  162,  156,  155,  154,  152,  151,  150,
      149,  147,  146,  137,  136,  135,  134,  133,  132,  131,
      130,  129,  127,  126,  117,  116,  115,  114,  113,  112,
      111,  110,  109,  108,  107,  106,   95,   94,   93,   92,
       91,   90,   89,   88,   87,   86,   85,   83,   72,   71,
       70,   68,   67,   66,   65,   64,   63,   62,   61,   50,

       49,   48,   46,   45,   44,   43,   42,   41,   40,   29,
       19,   10,    3,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
      229
    } ;

static yy_rs__state_type yy_rs__last_accepting_state;
static char *yy_rs__last_accepting_cpos;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT_rs_ which flex missed.
 */
#define REJECT_rs_ reject_used_but_not_detected
#define yy_rs_more() yy_rs_more_used_but_not_detected
#define YY_rs__MORE_ADJ 0
#define YY_rs__RESTORE_YY_rs__MORE_OFFSET
char *yy_rs_text;
#line 1 "run_str.l"
#define INITIAL_rs_ 0
#line 2 "run_str.l"
/*
    Clif - A C-like Interpreter Framework
    Copyright (C) 1992, 1993, 1994, 1995, 1996, 1997 T. Hruz, L. Koren
    1998 L. Koren

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/
/*
 * run_str.l
 *
 * lex source for run string analysis
 */
#include<stdio.h>
#include<string.h>
#ifdef input_rs_
#undef input_rs_
#undef yy_rs_wrap
#endif
#include"buf.h"
#include"rs-parser.h"
#include"init_rs.c"

#ifndef PROTO
#if defined (USE_PROTOTYPES) ? USE_PROTOTYPES : defined(__STDC__)
#define PROTO(ARGS) ARGS
#else
#define PROTO(ARGS) ()
#endif 
#endif

#ifdef FLEX_SCANNER
#define YY_rs__NO_UNPUT
#endif

extern char *string PROTO((char *));
#line 568 "lex.yy_rs_.c"

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_rs__SKIP_YY_rs_WRAP
#ifdef __cplusplus
extern "C" int yy_rs_wrap YY_rs__PROTO(( void ));
#else
extern int yy_rs_wrap YY_rs__PROTO(( void ));
#endif
#endif

#ifndef YY_rs__NO_UNPUT
static void yy_rs_unput_rs_ YY_rs__PROTO(( int c, char *buf_ptr ));
#endif

#ifndef yy_rs_text_ptr
static void yy_rs__flex_strncpy YY_rs__PROTO(( char *, yy_rs_const char *, int ));
#endif

#ifdef YY_rs__NEED_STRLEN
static int yy_rs__flex_strlen YY_rs__PROTO(( yy_rs_const char * ));
#endif

#ifndef YY_rs__NO_INPUT
#ifdef __cplusplus
static int yy_rs_input_rs_ YY_rs__PROTO(( void ));
#else
static int input_rs_ YY_rs__PROTO(( void ));
#endif
#endif

#if YY_rs__STACK_USED
static int yy_rs__start_stack_ptr = 0;
static int yy_rs__start_stack_depth = 0;
static int *yy_rs__start_stack = 0;
#ifndef YY_rs__NO_PUSH_STATE
static void yy_rs__push_state YY_rs__PROTO(( int new_state ));
#endif
#ifndef YY_rs__NO_POP_STATE
static void yy_rs__pop_state YY_rs__PROTO(( void ));
#endif
#ifndef YY_rs__NO_TOP_STATE
static int yy_rs__top_state YY_rs__PROTO(( void ));
#endif

#else
#define YY_rs__NO_PUSH_STATE 1
#define YY_rs__NO_POP_STATE 1
#define YY_rs__NO_TOP_STATE 1
#endif

#ifdef YY_rs__MALLOC_DECL
YY_rs__MALLOC_DECL
#else
#if __STDC__
#ifndef __cplusplus
#include <stdlib.h>
#endif
#else
/* Just try to get by without declaring the routines.  This will fail
 * miserably on non-ANSI systems for which sizeof(size_t) != sizeof(int)
 * or sizeof(void*) != sizeof(int).
 */
#endif
#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_rs__READ_BUF_SIZE
#define YY_rs__READ_BUF_SIZE 8192
#endif

/* Copy whatever the last rule matched to the standard output_rs_. */

#ifndef ECHO_rs_
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO_rs_ (void) fwrite( yy_rs_text, yy_rs_leng, 1, yy_rs_out )
#endif

/* Gets input_rs_ and stuffs it into "buf".  number of characters read, or YY_rs__NULL,
 * is returned in "result".
 */
#ifndef YY_rs__INPUT
#define YY_rs__INPUT(buf,result,max_size) \
	if ( yy_rs__current_buffer->yy_rs__is_interactive ) \
		{ \
		int c = '*', n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yy_rs_in )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yy_rs_in ) ) \
			YY_rs__FATAL_ERROR( "input_rs_ in flex scanner failed" ); \
		result = n; \
		} \
	else if ( ((result = fread( buf, 1, max_size, yy_rs_in )) == 0) \
		  && ferror( yy_rs_in ) ) \
		YY_rs__FATAL_ERROR( "input_rs_ in flex scanner failed" );
#endif

/* No semi-colon after return; correct usage is to write "yy_rs_terminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yy_rs_terminate
#define yy_rs_terminate() return YY_rs__NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_rs__START_STACK_INCR
#define YY_rs__START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_rs__FATAL_ERROR
#define YY_rs__FATAL_ERROR(msg) yy_rs__fatal_error( msg )
#endif

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_rs__DECL
#define YY_rs__DECL int yy_rs_lex YY_rs__PROTO(( void ))
#endif

/* Code executed at the beginning of each rule, after yy_rs_text and yy_rs_leng
 * have been set up.
 */
#ifndef YY_rs__USER_ACTION
#define YY_rs__USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_rs__BREAK
#define YY_rs__BREAK break;
#endif

#define YY_rs__RULE_SETUP \
	YY_rs__USER_ACTION

YY_rs__DECL
	{
	register yy_rs__state_type yy_rs__current_state;
	register char *yy_rs__cp, *yy_rs__bp;
	register int yy_rs__act;

#line 69 "run_str.l"

#line 721 "lex.yy_rs_.c"

	if ( yy_rs__init )
		{
		yy_rs__init = 0;

#ifdef YY_rs__USER_INIT
		YY_rs__USER_INIT;
#endif

		if ( ! yy_rs__start )
			yy_rs__start = 1;	/* first start state */

		if ( ! yy_rs_in )
			yy_rs_in = stdin;

		if ( ! yy_rs_out )
			yy_rs_out = stdout;

		if ( ! yy_rs__current_buffer )
			yy_rs__current_buffer =
				yy_rs__create_buffer( yy_rs_in, YY_rs__BUF_SIZE );

		yy_rs__load_buffer_state();
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_rs__cp = yy_rs__c_buf_p;

		/* Support of yy_rs_text. */
		*yy_rs__cp = yy_rs__hold_char;

		/* yy_rs__bp points to the position in yy_rs__ch_buf of the start of
		 * the current run.
		 */
		yy_rs__bp = yy_rs__cp;

		yy_rs__current_state = yy_rs__start;
yy_rs__match:
		do
			{
			register YY_rs__CHAR yy_rs__c = yy_rs__ec[YY_rs__SC_TO_UI(*yy_rs__cp)];
			if ( yy_rs__accept[yy_rs__current_state] )
				{
				yy_rs__last_accepting_state = yy_rs__current_state;
				yy_rs__last_accepting_cpos = yy_rs__cp;
				}
			while ( yy_rs__chk[yy_rs__base[yy_rs__current_state] + yy_rs__c] != yy_rs__current_state )
				{
				yy_rs__current_state = (int) yy_rs__def[yy_rs__current_state];
				if ( yy_rs__current_state >= 230 )
					yy_rs__c = yy_rs__meta[(unsigned int) yy_rs__c];
				}
			yy_rs__current_state = yy_rs__nxt[yy_rs__base[yy_rs__current_state] + (unsigned int) yy_rs__c];
			++yy_rs__cp;
			}
		while ( yy_rs__base[yy_rs__current_state] != 314 );

yy_rs__find_action:
		yy_rs__act = yy_rs__accept[yy_rs__current_state];
		if ( yy_rs__act == 0 )
			{ /* have to back up */
			yy_rs__cp = yy_rs__last_accepting_cpos;
			yy_rs__current_state = yy_rs__last_accepting_state;
			yy_rs__act = yy_rs__accept[yy_rs__current_state];
			}

		YY_rs__DO_BEFORE_ACTION;


do_action:	/* This label is used only to access EOF actions. */


		switch ( yy_rs__act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_rs__DO_BEFORE_ACTION */
			*yy_rs__cp = yy_rs__hold_char;
			yy_rs__cp = yy_rs__last_accepting_cpos;
			yy_rs__current_state = yy_rs__last_accepting_state;
			goto yy_rs__find_action;

case 1:
YY_rs__RULE_SETUP
#line 70 "run_str.l"
{}
	YY_rs__BREAK
case 2:
YY_rs__RULE_SETUP
#line 71 "run_str.l"
{;}
	YY_rs__BREAK
case 3:
YY_rs__RULE_SETUP
#line 72 "run_str.l"
{sscanf (yy_rs_text, "%d", &yy_rs_lval.myy_rs_int); return (NUMBER);
			 /* 
 			  * Matches an integer number.
 			  */}
	YY_rs__BREAK
case 4:
YY_rs__RULE_SETUP
#line 76 "run_str.l"
{return (BGC);}
	YY_rs__BREAK
case 5:
YY_rs__RULE_SETUP
#line 77 "run_str.l"
{return (BGC); 
			 /* 
			  * Redefining of size of framework memory.
			  */}
	YY_rs__BREAK
case 6:
YY_rs__RULE_SETUP
#line 81 "run_str.l"
{return (DUMP_YACC);}
	YY_rs__BREAK
case 7:
YY_rs__RULE_SETUP
#line 82 "run_str.l"
{return (CALL_BY_REFERENCE);}
	YY_rs__BREAK
case 8:
YY_rs__RULE_SETUP
#line 83 "run_str.l"
{return (NO_CALL_BY_REFERENCE);}
	YY_rs__BREAK
case 9:
YY_rs__RULE_SETUP
#line 84 "run_str.l"
{return (CALL_BY_VALUE);}
	YY_rs__BREAK
case 10:
YY_rs__RULE_SETUP
#line 85 "run_str.l"
{return (NO_CALL_BY_VALUE);}
	YY_rs__BREAK
case 11:
YY_rs__RULE_SETUP
#line 86 "run_str.l"
{return (HANDLE_MAIN);}
	YY_rs__BREAK
case 12:
YY_rs__RULE_SETUP
#line 87 "run_str.l"
{return (DBG_INFO);}
	YY_rs__BREAK
case 13:
YY_rs__RULE_SETUP
#line 88 "run_str.l"
{return (HELP);}
	YY_rs__BREAK
case 14:
YY_rs__RULE_SETUP
#line 89 "run_str.l"
{return (HELP);}
	YY_rs__BREAK
case 15:
YY_rs__RULE_SETUP
#line 90 "run_str.l"
{return (HELP);
			 /* 
			  * Starts a help.
			  */}
	YY_rs__BREAK
case 16:
YY_rs__RULE_SETUP
#line 94 "run_str.l"
{return (HELP); /* Starts a help. */}
	YY_rs__BREAK
case 17:
YY_rs__RULE_SETUP
#line 95 "run_str.l"
{return (HELP); /* Starts a help. */}
	YY_rs__BREAK
case 18:
YY_rs__RULE_SETUP
#line 96 "run_str.l"
{return (HELP); /* Starts a help */}
	YY_rs__BREAK
case 19:
YY_rs__RULE_SETUP
#line 97 "run_str.l"
{return (HELP); /* Starts a help */}
	YY_rs__BREAK
case 20:
YY_rs__RULE_SETUP
#line 98 "run_str.l"
{return (COPYING); /* Starts copying policy */}
	YY_rs__BREAK
case 21:
YY_rs__RULE_SETUP
#line 99 "run_str.l"
{return (COPYING);}
	YY_rs__BREAK
case 22:
YY_rs__RULE_SETUP
#line 100 "run_str.l"
{return (COPYING);}
	YY_rs__BREAK
case 23:
YY_rs__RULE_SETUP
#line 101 "run_str.l"
{return (WARNING_INHIBIT); /* Starts warranty */}
	YY_rs__BREAK
case 24:
YY_rs__RULE_SETUP
#line 102 "run_str.l"
{return (WARRANTY); /* Starts warranty */}
	YY_rs__BREAK
case 25:
YY_rs__RULE_SETUP
#line 103 "run_str.l"
{return (WARRANTY);}
	YY_rs__BREAK
case 26:
YY_rs__RULE_SETUP
#line 104 "run_str.l"
{return (WARRANTY);}
	YY_rs__BREAK
case 27:
YY_rs__RULE_SETUP
#line 105 "run_str.l"
{return (COMPILE); /* Starts compiling only */}
	YY_rs__BREAK
case 28:
YY_rs__RULE_SETUP
#line 106 "run_str.l"
{return (WARNING_EXTRA);}
	YY_rs__BREAK
case 29:
YY_rs__RULE_SETUP
#line 107 "run_str.l"
{return (WARNING_AGGREGATE_RETURN);}
	YY_rs__BREAK
case 30:
YY_rs__RULE_SETUP
#line 108 "run_str.l"
{return (WARNING_COMMENT);}
	YY_rs__BREAK
case 31:
YY_rs__RULE_SETUP
#line 109 "run_str.l"
{return (WARNING_ERROR);}
	YY_rs__BREAK
case 32:
YY_rs__RULE_SETUP
#line 110 "run_str.l"
{return (WARNING_FORMAT);}
	YY_rs__BREAK
case 33:
YY_rs__RULE_SETUP
#line 111 "run_str.l"
{return (WARNING_IMPLICIT);}
	YY_rs__BREAK
case 34:
YY_rs__RULE_SETUP
#line 112 "run_str.l"
{return (WARNING_RETURN_TYPE);}
	YY_rs__BREAK
case 35:
YY_rs__RULE_SETUP
#line 113 "run_str.l"
{return (WARNING_TRIGRAPHS);}
	YY_rs__BREAK
case 36:
YY_rs__RULE_SETUP
#line 114 "run_str.l"
{return (WARNING_UNINITIAL_rs_IZED);}
	YY_rs__BREAK
case 37:
YY_rs__RULE_SETUP
#line 115 "run_str.l"
{return (WARNING_UNUSED);}
	YY_rs__BREAK
case 38:
YY_rs__RULE_SETUP
#line 116 "run_str.l"
{return (WARNING); /* Prints warnings as well */}
	YY_rs__BREAK
case 39:
YY_rs__RULE_SETUP
#line 117 "run_str.l"
{return (VERSION); /* Prints version number */}
	YY_rs__BREAK
case 40:
YY_rs__RULE_SETUP
#line 118 "run_str.l"
{return (VERSION); /* Prints version number */}
	YY_rs__BREAK
case 41:
YY_rs__RULE_SETUP
#line 119 "run_str.l"
{return (VERSION); /* Prints version number */}
	YY_rs__BREAK
case 42:
YY_rs__RULE_SETUP
#line 120 "run_str.l"
{return (VERSION); /* Prints version number */}
	YY_rs__BREAK
case 43:
YY_rs__RULE_SETUP
#line 121 "run_str.l"
{return (VERBOSE); /* Prints message about environment */}
	YY_rs__BREAK
case 44:
YY_rs__RULE_SETUP
#line 122 "run_str.l"
{return (VERBOSE); /* Prints message about environment */}
	YY_rs__BREAK
case 45:
YY_rs__RULE_SETUP
#line 123 "run_str.l"
{/*
		  * Other run string parameters.
		  */
		 yy_rs_lval.myy_rs_string = string (yy_rs_text);
		 return(STRING);}
	YY_rs__BREAK
case 46:
YY_rs__RULE_SETUP
#line 128 "run_str.l"
{return (*yy_rs_text);}
	YY_rs__BREAK
case 47:
YY_rs__RULE_SETUP
#line 129 "run_str.l"
ECHO_rs_;
	YY_rs__BREAK
#line 1052 "lex.yy_rs_.c"
case YY_rs__STATE_EOF(INITIAL_rs_):
	yy_rs_terminate();

	case YY_rs__END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_rs__amount_of_matched_text = (int) (yy_rs__cp - yy_rs_text_ptr) - 1;

		/* Undo the effects of YY_rs__DO_BEFORE_ACTION. */
		*yy_rs__cp = yy_rs__hold_char;
		YY_rs__RESTORE_YY_rs__MORE_OFFSET

		if ( yy_rs__current_buffer->yy_rs__buffer_status == YY_rs__BUFFER_NEW )
			{
			/* We're scanning a new file or input_rs_ source.  It's
			 * possible that this happened because the user
			 * just pointed yy_rs_in at a new source and called
			 * yy_rs_lex().  If so, then we have to assure
			 * consistency between yy_rs__current_buffer and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input_rs_ source.
			 */
			yy_rs__n_chars = yy_rs__current_buffer->yy_rs__n_chars;
			yy_rs__current_buffer->yy_rs__input_rs__file = yy_rs_in;
			yy_rs__current_buffer->yy_rs__buffer_status = YY_rs__BUFFER_NORMAL;
			}

		/* Note that here we test for yy_rs__c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_rs__c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input_rs_().
		 */
		if ( yy_rs__c_buf_p <= &yy_rs__current_buffer->yy_rs__ch_buf[yy_rs__n_chars] )
			{ /* This was really a NUL. */
			yy_rs__state_type yy_rs__next_state;

			yy_rs__c_buf_p = yy_rs_text_ptr + yy_rs__amount_of_matched_text;

			yy_rs__current_state = yy_rs__get_previous_state();

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_rs__get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_rs__next_state = yy_rs__try_NUL_trans( yy_rs__current_state );

			yy_rs__bp = yy_rs_text_ptr + YY_rs__MORE_ADJ;

			if ( yy_rs__next_state )
				{
				/* Consume the NUL. */
				yy_rs__cp = ++yy_rs__c_buf_p;
				yy_rs__current_state = yy_rs__next_state;
				goto yy_rs__match;
				}

			else
				{
				yy_rs__cp = yy_rs__c_buf_p;
				goto yy_rs__find_action;
				}
			}

		else switch ( yy_rs__get_next_buffer() )
			{
			case EOB_ACT_END_OF_FILE:
				{
				yy_rs__did_buffer_switch_on_eof = 0;

				if ( yy_rs_wrap() )
					{
					/* Note: because we've taken care in
					 * yy_rs__get_next_buffer() to have set up
					 * yy_rs_text, we can now set up
					 * yy_rs__c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_rs__NULL, it'll still work - another
					 * YY_rs__NULL will get returned.
					 */
					yy_rs__c_buf_p = yy_rs_text_ptr + YY_rs__MORE_ADJ;

					yy_rs__act = YY_rs__STATE_EOF(YY_rs__START);
					goto do_action;
					}

				else
					{
					if ( ! yy_rs__did_buffer_switch_on_eof )
						YY_rs__NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				yy_rs__c_buf_p =
					yy_rs_text_ptr + yy_rs__amount_of_matched_text;

				yy_rs__current_state = yy_rs__get_previous_state();

				yy_rs__cp = yy_rs__c_buf_p;
				yy_rs__bp = yy_rs_text_ptr + YY_rs__MORE_ADJ;
				goto yy_rs__match;

			case EOB_ACT_LAST_MATCH:
				yy_rs__c_buf_p =
				&yy_rs__current_buffer->yy_rs__ch_buf[yy_rs__n_chars];

				yy_rs__current_state = yy_rs__get_previous_state();

				yy_rs__cp = yy_rs__c_buf_p;
				yy_rs__bp = yy_rs_text_ptr + YY_rs__MORE_ADJ;
				goto yy_rs__find_action;
			}
		break;
		}

	default:
		YY_rs__FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
	} /* end of yy_rs_lex */


/* yy_rs__get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */

static int yy_rs__get_next_buffer()
	{
	register char *dest = yy_rs__current_buffer->yy_rs__ch_buf;
	register char *source = yy_rs_text_ptr;
	register int number_to_move, i;
	int ret_val;

	if ( yy_rs__c_buf_p > &yy_rs__current_buffer->yy_rs__ch_buf[yy_rs__n_chars + 1] )
		YY_rs__FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( yy_rs__current_buffer->yy_rs__fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( yy_rs__c_buf_p - yy_rs_text_ptr - YY_rs__MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) (yy_rs__c_buf_p - yy_rs_text_ptr) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( yy_rs__current_buffer->yy_rs__buffer_status == YY_rs__BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		yy_rs__current_buffer->yy_rs__n_chars = yy_rs__n_chars = 0;

	else
		{
		int num_to_read =
			yy_rs__current_buffer->yy_rs__buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */
#ifdef YY_rs__USES_REJECT_rs_
			YY_rs__FATAL_ERROR(
"input_rs_ buffer overflow, can't enlarge buffer because scanner uses REJECT_rs_" );
#else

			/* just a shorter name for the current buffer */
			YY_rs__BUFFER_STATE b = yy_rs__current_buffer;

			int yy_rs__c_buf_p_offset =
				(int) (yy_rs__c_buf_p - b->yy_rs__ch_buf);

			if ( b->yy_rs__is_our_buffer )
				{
				int new_size = b->yy_rs__buf_size * 2;

				if ( new_size <= 0 )
					b->yy_rs__buf_size += b->yy_rs__buf_size / 8;
				else
					b->yy_rs__buf_size *= 2;

				b->yy_rs__ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yy_rs__flex_realloc( (void *) b->yy_rs__ch_buf,
							 b->yy_rs__buf_size + 2 );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_rs__ch_buf = 0;

			if ( ! b->yy_rs__ch_buf )
				YY_rs__FATAL_ERROR(
				"fatal error - scanner input_rs_ buffer overflow" );

			yy_rs__c_buf_p = &b->yy_rs__ch_buf[yy_rs__c_buf_p_offset];

			num_to_read = yy_rs__current_buffer->yy_rs__buf_size -
						number_to_move - 1;
#endif
			}

		if ( num_to_read > YY_rs__READ_BUF_SIZE )
			num_to_read = YY_rs__READ_BUF_SIZE;

		/* Read in more data. */
		YY_rs__INPUT( (&yy_rs__current_buffer->yy_rs__ch_buf[number_to_move]),
			yy_rs__n_chars, num_to_read );

		yy_rs__current_buffer->yy_rs__n_chars = yy_rs__n_chars;
		}

	if ( yy_rs__n_chars == 0 )
		{
		if ( number_to_move == YY_rs__MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yy_rs_restart( yy_rs_in );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			yy_rs__current_buffer->yy_rs__buffer_status =
				YY_rs__BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	yy_rs__n_chars += number_to_move;
	yy_rs__current_buffer->yy_rs__ch_buf[yy_rs__n_chars] = YY_rs__END_OF_BUFFER_CHAR;
	yy_rs__current_buffer->yy_rs__ch_buf[yy_rs__n_chars + 1] = YY_rs__END_OF_BUFFER_CHAR;

	yy_rs_text_ptr = &yy_rs__current_buffer->yy_rs__ch_buf[0];

	return ret_val;
	}


/* yy_rs__get_previous_state - get the state just before the EOB char was reached */

static yy_rs__state_type yy_rs__get_previous_state()
	{
	register yy_rs__state_type yy_rs__current_state;
	register char *yy_rs__cp;

	yy_rs__current_state = yy_rs__start;

	for ( yy_rs__cp = yy_rs_text_ptr + YY_rs__MORE_ADJ; yy_rs__cp < yy_rs__c_buf_p; ++yy_rs__cp )
		{
		register YY_rs__CHAR yy_rs__c = (*yy_rs__cp ? yy_rs__ec[YY_rs__SC_TO_UI(*yy_rs__cp)] : 1);
		if ( yy_rs__accept[yy_rs__current_state] )
			{
			yy_rs__last_accepting_state = yy_rs__current_state;
			yy_rs__last_accepting_cpos = yy_rs__cp;
			}
		while ( yy_rs__chk[yy_rs__base[yy_rs__current_state] + yy_rs__c] != yy_rs__current_state )
			{
			yy_rs__current_state = (int) yy_rs__def[yy_rs__current_state];
			if ( yy_rs__current_state >= 230 )
				yy_rs__c = yy_rs__meta[(unsigned int) yy_rs__c];
			}
		yy_rs__current_state = yy_rs__nxt[yy_rs__base[yy_rs__current_state] + (unsigned int) yy_rs__c];
		}

	return yy_rs__current_state;
	}


/* yy_rs__try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_rs__try_NUL_trans( current_state );
 */

#ifdef YY_rs__USE_PROTOS
static yy_rs__state_type yy_rs__try_NUL_trans( yy_rs__state_type yy_rs__current_state )
#else
static yy_rs__state_type yy_rs__try_NUL_trans( yy_rs__current_state )
yy_rs__state_type yy_rs__current_state;
#endif
	{
	register int yy_rs__is_jam;
	register char *yy_rs__cp = yy_rs__c_buf_p;

	register YY_rs__CHAR yy_rs__c = 1;
	if ( yy_rs__accept[yy_rs__current_state] )
		{
		yy_rs__last_accepting_state = yy_rs__current_state;
		yy_rs__last_accepting_cpos = yy_rs__cp;
		}
	while ( yy_rs__chk[yy_rs__base[yy_rs__current_state] + yy_rs__c] != yy_rs__current_state )
		{
		yy_rs__current_state = (int) yy_rs__def[yy_rs__current_state];
		if ( yy_rs__current_state >= 230 )
			yy_rs__c = yy_rs__meta[(unsigned int) yy_rs__c];
		}
	yy_rs__current_state = yy_rs__nxt[yy_rs__base[yy_rs__current_state] + (unsigned int) yy_rs__c];
	yy_rs__is_jam = (yy_rs__current_state == 229);

	return yy_rs__is_jam ? 0 : yy_rs__current_state;
	}


#ifndef YY_rs__NO_UNPUT
#ifdef YY_rs__USE_PROTOS
static void yy_rs_unput_rs_( int c, register char *yy_rs__bp )
#else
static void yy_rs_unput_rs_( c, yy_rs__bp )
int c;
register char *yy_rs__bp;
#endif
	{
	register char *yy_rs__cp = yy_rs__c_buf_p;

	/* undo effects of setting up yy_rs_text */
	*yy_rs__cp = yy_rs__hold_char;

	if ( yy_rs__cp < yy_rs__current_buffer->yy_rs__ch_buf + 2 )
		{ /* need to shift things up to make room */
		/* +2 for EOB chars. */
		register int number_to_move = yy_rs__n_chars + 2;
		register char *dest = &yy_rs__current_buffer->yy_rs__ch_buf[
					yy_rs__current_buffer->yy_rs__buf_size + 2];
		register char *source =
				&yy_rs__current_buffer->yy_rs__ch_buf[number_to_move];

		while ( source > yy_rs__current_buffer->yy_rs__ch_buf )
			*--dest = *--source;

		yy_rs__cp += (int) (dest - source);
		yy_rs__bp += (int) (dest - source);
		yy_rs__current_buffer->yy_rs__n_chars =
			yy_rs__n_chars = yy_rs__current_buffer->yy_rs__buf_size;

		if ( yy_rs__cp < yy_rs__current_buffer->yy_rs__ch_buf + 2 )
			YY_rs__FATAL_ERROR( "flex scanner push-back overflow" );
		}

	*--yy_rs__cp = (char) c;


	yy_rs_text_ptr = yy_rs__bp;
	yy_rs__hold_char = *yy_rs__cp;
	yy_rs__c_buf_p = yy_rs__cp;
	}
#endif	/* ifndef YY_rs__NO_UNPUT */


#ifdef __cplusplus
static int yy_rs_input_rs_()
#else
static int input_rs_()
#endif
	{
	int c;

	*yy_rs__c_buf_p = yy_rs__hold_char;

	if ( *yy_rs__c_buf_p == YY_rs__END_OF_BUFFER_CHAR )
		{
		/* yy_rs__c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( yy_rs__c_buf_p < &yy_rs__current_buffer->yy_rs__ch_buf[yy_rs__n_chars] )
			/* This was really a NUL. */
			*yy_rs__c_buf_p = '\0';

		else
			{ /* need more input_rs_ */
			int offset = yy_rs__c_buf_p - yy_rs_text_ptr;
			++yy_rs__c_buf_p;

			switch ( yy_rs__get_next_buffer() )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_rs__g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input_rs_(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yy_rs_restart( yy_rs_in );

					/* fall through */

				case EOB_ACT_END_OF_FILE:
					{
					if ( yy_rs_wrap() )
						return EOF;

					if ( ! yy_rs__did_buffer_switch_on_eof )
						YY_rs__NEW_FILE;
#ifdef __cplusplus
					return yy_rs_input_rs_();
#else
					return input_rs_();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					yy_rs__c_buf_p = yy_rs_text_ptr + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) yy_rs__c_buf_p;	/* cast for 8-bit char's */
	*yy_rs__c_buf_p = '\0';	/* preserve yy_rs_text */
	yy_rs__hold_char = *++yy_rs__c_buf_p;


	return c;
	}


#ifdef YY_rs__USE_PROTOS
void yy_rs_restart( FILE *input_rs__file )
#else
void yy_rs_restart( input_rs__file )
FILE *input_rs__file;
#endif
	{
	if ( ! yy_rs__current_buffer )
		yy_rs__current_buffer = yy_rs__create_buffer( yy_rs_in, YY_rs__BUF_SIZE );

	yy_rs__init_buffer( yy_rs__current_buffer, input_rs__file );
	yy_rs__load_buffer_state();
	}


#ifdef YY_rs__USE_PROTOS
void yy_rs__switch_to_buffer( YY_rs__BUFFER_STATE new_buffer )
#else
void yy_rs__switch_to_buffer( new_buffer )
YY_rs__BUFFER_STATE new_buffer;
#endif
	{
	if ( yy_rs__current_buffer == new_buffer )
		return;

	if ( yy_rs__current_buffer )
		{
		/* Flush out information for old buffer. */
		*yy_rs__c_buf_p = yy_rs__hold_char;
		yy_rs__current_buffer->yy_rs__buf_pos = yy_rs__c_buf_p;
		yy_rs__current_buffer->yy_rs__n_chars = yy_rs__n_chars;
		}

	yy_rs__current_buffer = new_buffer;
	yy_rs__load_buffer_state();

	/* We don't actually know whether we did this switch during
	 * EOF (yy_rs_wrap()) processing, but the only time this flag
	 * is looked at is after yy_rs_wrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	yy_rs__did_buffer_switch_on_eof = 1;
	}


#ifdef YY_rs__USE_PROTOS
void yy_rs__load_buffer_state( void )
#else
void yy_rs__load_buffer_state()
#endif
	{
	yy_rs__n_chars = yy_rs__current_buffer->yy_rs__n_chars;
	yy_rs_text_ptr = yy_rs__c_buf_p = yy_rs__current_buffer->yy_rs__buf_pos;
	yy_rs_in = yy_rs__current_buffer->yy_rs__input_rs__file;
	yy_rs__hold_char = *yy_rs__c_buf_p;
	}


#ifdef YY_rs__USE_PROTOS
YY_rs__BUFFER_STATE yy_rs__create_buffer( FILE *file, int size )
#else
YY_rs__BUFFER_STATE yy_rs__create_buffer( file, size )
FILE *file;
int size;
#endif
	{
	YY_rs__BUFFER_STATE b;

	b = (YY_rs__BUFFER_STATE) yy_rs__flex_alloc( sizeof( struct yy_rs__buffer_state ) );
	if ( ! b )
		YY_rs__FATAL_ERROR( "out of dynamic memory in yy_rs__create_buffer()" );

	b->yy_rs__buf_size = size;

	/* yy_rs__ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_rs__ch_buf = (char *) yy_rs__flex_alloc( b->yy_rs__buf_size + 2 );
	if ( ! b->yy_rs__ch_buf )
		YY_rs__FATAL_ERROR( "out of dynamic memory in yy_rs__create_buffer()" );

	b->yy_rs__is_our_buffer = 1;

	yy_rs__init_buffer( b, file );

	return b;
	}


#ifdef YY_rs__USE_PROTOS
void yy_rs__delete_buffer( YY_rs__BUFFER_STATE b )
#else
void yy_rs__delete_buffer( b )
YY_rs__BUFFER_STATE b;
#endif
	{
	if ( ! b )
		return;

	if ( b == yy_rs__current_buffer )
		yy_rs__current_buffer = (YY_rs__BUFFER_STATE) 0;

	if ( b->yy_rs__is_our_buffer )
		yy_rs__flex_free( (void *) b->yy_rs__ch_buf );

	yy_rs__flex_free( (void *) b );
	}


#ifndef YY_rs__ALWAYS_INTERACTIVE
#ifndef YY_rs__NEVER_INTERACTIVE
extern int isatty YY_rs__PROTO(( int ));
#endif
#endif

#ifdef YY_rs__USE_PROTOS
void yy_rs__init_buffer( YY_rs__BUFFER_STATE b, FILE *file )
#else
void yy_rs__init_buffer( b, file )
YY_rs__BUFFER_STATE b;
FILE *file;
#endif


	{
	yy_rs__flush_buffer( b );

	b->yy_rs__input_rs__file = file;
	b->yy_rs__fill_buffer = 1;

#if YY_rs__ALWAYS_INTERACTIVE
	b->yy_rs__is_interactive = 1;
#else
#if YY_rs__NEVER_INTERACTIVE
	b->yy_rs__is_interactive = 0;
#else
	b->yy_rs__is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
#endif
#endif
	}


#ifdef YY_rs__USE_PROTOS
void yy_rs__flush_buffer( YY_rs__BUFFER_STATE b )
#else
void yy_rs__flush_buffer( b )
YY_rs__BUFFER_STATE b;
#endif

	{
	if ( ! b )
		return;

	b->yy_rs__n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_rs__ch_buf[0] = YY_rs__END_OF_BUFFER_CHAR;
	b->yy_rs__ch_buf[1] = YY_rs__END_OF_BUFFER_CHAR;

	b->yy_rs__buf_pos = &b->yy_rs__ch_buf[0];

	b->yy_rs__at_bol = 1;
	b->yy_rs__buffer_status = YY_rs__BUFFER_NEW;

	if ( b == yy_rs__current_buffer )
		yy_rs__load_buffer_state();
	}


#ifndef YY_rs__NO_SCAN_BUFFER
#ifdef YY_rs__USE_PROTOS
YY_rs__BUFFER_STATE yy_rs__scan_buffer( char *base, yy_rs__size_t size )
#else
YY_rs__BUFFER_STATE yy_rs__scan_buffer( base, size )
char *base;
yy_rs__size_t size;
#endif
	{
	YY_rs__BUFFER_STATE b;

	if ( size < 2 ||
	     base[size-2] != YY_rs__END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_rs__END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_rs__BUFFER_STATE) yy_rs__flex_alloc( sizeof( struct yy_rs__buffer_state ) );
	if ( ! b )
		YY_rs__FATAL_ERROR( "out of dynamic memory in yy_rs__scan_buffer()" );

	b->yy_rs__buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_rs__buf_pos = b->yy_rs__ch_buf = base;
	b->yy_rs__is_our_buffer = 0;
	b->yy_rs__input_rs__file = 0;
	b->yy_rs__n_chars = b->yy_rs__buf_size;
	b->yy_rs__is_interactive = 0;
	b->yy_rs__at_bol = 1;
	b->yy_rs__fill_buffer = 0;
	b->yy_rs__buffer_status = YY_rs__BUFFER_NEW;

	yy_rs__switch_to_buffer( b );

	return b;
	}
#endif


#ifndef YY_rs__NO_SCAN_STRING
#ifdef YY_rs__USE_PROTOS
YY_rs__BUFFER_STATE yy_rs__scan_string( yy_rs_const char *yy_rs__str )
#else
YY_rs__BUFFER_STATE yy_rs__scan_string( yy_rs__str )
yy_rs_const char *yy_rs__str;
#endif
	{
	int len;
	for ( len = 0; yy_rs__str[len]; ++len )
		;

	return yy_rs__scan_bytes( yy_rs__str, len );
	}
#endif


#ifndef YY_rs__NO_SCAN_BYTES
#ifdef YY_rs__USE_PROTOS
YY_rs__BUFFER_STATE yy_rs__scan_bytes( yy_rs_const char *bytes, int len )
#else
YY_rs__BUFFER_STATE yy_rs__scan_bytes( bytes, len )
yy_rs_const char *bytes;
int len;
#endif
	{
	YY_rs__BUFFER_STATE b;
	char *buf;
	yy_rs__size_t n;
	int i;

	/* Get memory for full buffer, including space for trailing EOB's. */
	n = len + 2;
	buf = (char *) yy_rs__flex_alloc( n );
	if ( ! buf )
		YY_rs__FATAL_ERROR( "out of dynamic memory in yy_rs__scan_bytes()" );

	for ( i = 0; i < len; ++i )
		buf[i] = bytes[i];

	buf[len] = buf[len+1] = YY_rs__END_OF_BUFFER_CHAR;

	b = yy_rs__scan_buffer( buf, n );
	if ( ! b )
		YY_rs__FATAL_ERROR( "bad buffer in yy_rs__scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_rs__is_our_buffer = 1;

	return b;
	}
#endif


#ifndef YY_rs__NO_PUSH_STATE
#ifdef YY_rs__USE_PROTOS
static void yy_rs__push_state( int new_state )
#else
static void yy_rs__push_state( new_state )
int new_state;
#endif
	{
	if ( yy_rs__start_stack_ptr >= yy_rs__start_stack_depth )
		{
		yy_rs__size_t new_size;

		yy_rs__start_stack_depth += YY_rs__START_STACK_INCR;
		new_size = yy_rs__start_stack_depth * sizeof( int );

		if ( ! yy_rs__start_stack )
			yy_rs__start_stack = (int *) yy_rs__flex_alloc( new_size );

		else
			yy_rs__start_stack = (int *) yy_rs__flex_realloc(
					(void *) yy_rs__start_stack, new_size );

		if ( ! yy_rs__start_stack )
			YY_rs__FATAL_ERROR(
			"out of memory expanding start-condition stack" );
		}

	yy_rs__start_stack[yy_rs__start_stack_ptr++] = YY_rs__START;

	BEGIN_rs_(new_state);
	}
#endif


#ifndef YY_rs__NO_POP_STATE
static void yy_rs__pop_state()
	{
	if ( --yy_rs__start_stack_ptr < 0 )
		YY_rs__FATAL_ERROR( "start-condition stack underflow" );

	BEGIN_rs_(yy_rs__start_stack[yy_rs__start_stack_ptr]);
	}
#endif


#ifndef YY_rs__NO_TOP_STATE
static int yy_rs__top_state()
	{
	return yy_rs__start_stack[yy_rs__start_stack_ptr - 1];
	}
#endif

#ifndef YY_rs__EXIT_FAILURE
#define YY_rs__EXIT_FAILURE 2
#endif

#ifdef YY_rs__USE_PROTOS
static void yy_rs__fatal_error( yy_rs_const char msg[] )
#else
static void yy_rs__fatal_error( msg )
char msg[];
#endif
	{
	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_rs__EXIT_FAILURE );
	}



/* Redefine yy_rs_less() so it works in section 3 code. */

#undef yy_rs_less
#define yy_rs_less(n) \
	do \
		{ \
		/* Undo effects of setting up yy_rs_text. */ \
		yy_rs_text[yy_rs_leng] = yy_rs__hold_char; \
		yy_rs__c_buf_p = yy_rs_text + n; \
		yy_rs__hold_char = *yy_rs__c_buf_p; \
		*yy_rs__c_buf_p = '\0'; \
		yy_rs_leng = n; \
		} \
	while ( 0 )


/* Internal utility routines. */

#ifndef yy_rs_text_ptr
#ifdef YY_rs__USE_PROTOS
static void yy_rs__flex_strncpy( char *s1, yy_rs_const char *s2, int n )
#else
static void yy_rs__flex_strncpy( s1, s2, n )
char *s1;
yy_rs_const char *s2;
int n;
#endif
	{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
	}
#endif

#ifdef YY_rs__NEED_STRLEN
#ifdef YY_rs__USE_PROTOS
static int yy_rs__flex_strlen( yy_rs_const char *s )
#else
static int yy_rs__flex_strlen( s )
yy_rs_const char *s;
#endif
	{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
	}
#endif


#ifdef YY_rs__USE_PROTOS
static void *yy_rs__flex_alloc( yy_rs__size_t size )
#else
static void *yy_rs__flex_alloc( size )
yy_rs__size_t size;
#endif
	{
	return (void *) malloc( size );
	}

#ifdef YY_rs__USE_PROTOS
static void *yy_rs__flex_realloc( void *ptr, yy_rs__size_t size )
#else
static void *yy_rs__flex_realloc( ptr, size )
void *ptr;
yy_rs__size_t size;
#endif
	{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
	}

#ifdef YY_rs__USE_PROTOS
static void yy_rs__flex_free( void *ptr )
#else
static void yy_rs__flex_free( ptr )
void *ptr;
#endif
	{
	free( ptr );
	}

#if YY_rs__MAIN
int main()
	{
	yy_rs_lex();
	return 0;
	}
#endif
#line 129 "run_str.l"

